diff -aruN --binary 15/media/system/js/validate.js 16/media/system/js/validate.js
--- 15/media/system/js/validate.js	2009-05-29 13:50:40.000000000 +0200
+++ 16/media/system/js/validate.js	2010-04-23 13:40:18.000000000 +0200
@@ -1,7 +1,7 @@
 /**
 * @version		$Id: validate.js 7401 2007-05-14 04:12:55Z eddieajau $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_archive/helper.php 16/modules/mod_archive/helper.php
--- 15/modules/mod_archive/helper.php	2009-05-29 13:54:06.000000000 +0200
+++ 16/modules/mod_archive/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 11646 2009-03-01 19:34:56Z ian $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_archive/mod_archive.php 16/modules/mod_archive/mod_archive.php
--- 15/modules/mod_archive/mod_archive.php	2009-05-29 13:54:06.000000000 +0200
+++ 16/modules/mod_archive/mod_archive.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_archive.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_archive.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_banners/helper.php 16/modules/mod_banners/helper.php
--- 15/modules/mod_banners/helper.php	2009-05-29 13:54:08.000000000 +0200
+++ 16/modules/mod_banners/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10554 2008-07-15 17:15:19Z ircmaxell $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_banners/mod_banners.php 16/modules/mod_banners/mod_banners.php
--- 15/modules/mod_banners/mod_banners.php	2009-05-29 13:54:08.000000000 +0200
+++ 16/modules/mod_banners/mod_banners.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_banners.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_banners.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_breadcrumbs/helper.php 16/modules/mod_breadcrumbs/helper.php
--- 15/modules/mod_breadcrumbs/helper.php	2009-05-29 13:54:08.000000000 +0200
+++ 16/modules/mod_breadcrumbs/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_breadcrumbs/mod_breadcrumbs.php 16/modules/mod_breadcrumbs/mod_breadcrumbs.php
--- 15/modules/mod_breadcrumbs/mod_breadcrumbs.php	2009-05-29 13:54:08.000000000 +0200
+++ 16/modules/mod_breadcrumbs/mod_breadcrumbs.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_breadcrumbs.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_breadcrumbs.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_feed/helper.php 16/modules/mod_feed/helper.php
--- 15/modules/mod_feed/helper.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_feed/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_feed/mod_feed.php 16/modules/mod_feed/mod_feed.php
--- 15/modules/mod_feed/mod_feed.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_feed/mod_feed.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_feed.php 11371 2008-12-30 01:31:50Z ian $
+* @version		$Id: mod_feed.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_footer/mod_footer.php 16/modules/mod_footer/mod_footer.php
--- 15/modules/mod_footer/mod_footer.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_footer/mod_footer.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_footer.php 12694 2009-09-11 21:03:02Z ian $
+* @version		$Id: mod_footer.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_latestnews/helper.php 16/modules/mod_latestnews/helper.php
--- 15/modules/mod_latestnews/helper.php	2009-05-29 13:54:08.000000000 +0200
+++ 16/modules/mod_latestnews/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10857 2008-08-30 06:41:16Z willebil $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_latestnews/mod_latestnews.php 16/modules/mod_latestnews/mod_latestnews.php
--- 15/modules/mod_latestnews/mod_latestnews.php	2009-05-29 13:54:08.000000000 +0200
+++ 16/modules/mod_latestnews/mod_latestnews.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_latestnews.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_latestnews.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_login/helper.php 16/modules/mod_login/helper.php
--- 15/modules/mod_login/helper.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_login/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 11668 2009-03-08 20:33:38Z willebil $
+* @version		$Id: helper.php 15198 2010-03-05 09:06:05Z ian $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
@@ -19,10 +19,20 @@
 	function getReturnURL($params, $type)
 	{
 		if($itemid =  $params->get($type))
-		{
-			$menu =& JSite::getMenu();
-			$item = $menu->getItem($itemid);
-			$url = JRoute::_($item->link.'&Itemid='.$itemid, false);
+		{  
+			$menu =& JSite::getMenu();  
+			$item = $menu->getItem($itemid); //var_dump($menu);die;
+			if ($item)
+			{
+				$url = JRoute::_($item->link.'&Itemid='.$itemid, false);
+			}
+			else
+			{
+			// stay on the same page
+			$uri = JFactory::getURI();
+			$url = $uri->toString(array('path', 'query', 'fragment'));
+			}
+				
 		}
 		else
 		{
diff -aruN --binary 15/modules/mod_login/mod_login.php 16/modules/mod_login/mod_login.php
--- 15/modules/mod_login/mod_login.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_login/mod_login.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_login.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_login.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_mainmenu/helper.php 16/modules/mod_mainmenu/helper.php
--- 15/modules/mod_mainmenu/helper.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_mainmenu/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 12694 2009-09-11 21:03:02Z ian $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_mainmenu/legacy.php 16/modules/mod_mainmenu/legacy.php
--- 15/modules/mod_mainmenu/legacy.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_mainmenu/legacy.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: legacy.php 12694 2009-09-11 21:03:02Z ian $
+* @version		$Id: legacy.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_mainmenu/mod_mainmenu.php 16/modules/mod_mainmenu/mod_mainmenu.php
--- 15/modules/mod_mainmenu/mod_mainmenu.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_mainmenu/mod_mainmenu.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_mainmenu.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_mainmenu.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_mostread/helper.php 16/modules/mod_mostread/helper.php
--- 15/modules/mod_mostread/helper.php	2009-05-29 13:54:16.000000000 +0200
+++ 16/modules/mod_mostread/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10857 2008-08-30 06:41:16Z willebil $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_mostread/mod_mostread.php 16/modules/mod_mostread/mod_mostread.php
--- 15/modules/mod_mostread/mod_mostread.php	2009-05-29 13:54:14.000000000 +0200
+++ 16/modules/mod_mostread/mod_mostread.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_mostread.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_mostread.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_newsflash/helper.php 16/modules/mod_newsflash/helper.php
--- 15/modules/mod_newsflash/helper.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_newsflash/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 13246 2009-10-20 04:24:06Z ian $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_newsflash/mod_newsflash.php 16/modules/mod_newsflash/mod_newsflash.php
--- 15/modules/mod_newsflash/mod_newsflash.php	2009-05-29 13:54:10.000000000 +0200
+++ 16/modules/mod_newsflash/mod_newsflash.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_newsflash.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_newsflash.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_poll/helper.php 16/modules/mod_poll/helper.php
--- 15/modules/mod_poll/helper.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_poll/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_poll/mod_poll.php 16/modules/mod_poll/mod_poll.php
--- 15/modules/mod_poll/mod_poll.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_poll/mod_poll.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_poll.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_poll.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_random_image/helper.php 16/modules/mod_random_image/helper.php
--- 15/modules/mod_random_image/helper.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_random_image/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 12694 2009-09-11 21:03:02Z ian $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_random_image/mod_random_image.php 16/modules/mod_random_image/mod_random_image.php
--- 15/modules/mod_random_image/mod_random_image.php	2009-05-29 13:54:06.000000000 +0200
+++ 16/modules/mod_random_image/mod_random_image.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_random_image.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_random_image.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_related_items/helper.php 16/modules/mod_related_items/helper.php
--- 15/modules/mod_related_items/helper.php	2009-05-29 13:54:04.000000000 +0200
+++ 16/modules/mod_related_items/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 11137 2008-10-15 19:47:01Z kdevine $
+* @version		$Id: helper.php 15200 2010-03-05 09:12:56Z ian $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
@@ -23,7 +23,7 @@
 		global $mainframe;
 
 		$db					=& JFactory::getDBO();
-		$user				=& JFactory::getUser();
+		$user =& JFactory::getUser();
 
 		$option				= JRequest::getCmd('option');
 		$view				= JRequest::getCmd('view');
@@ -32,75 +32,93 @@
 		$temp				= explode(':', $temp);
 		$id					= $temp[0];
 
-		$showDate			= $params->get('showDate', 0);
+		$aid = $user->get('aid', 0);
 
-		$nullDate			= $db->getNullDate();
+		$showDate			= $params->get('showDate', 0);
+		$conf =& JFactory::getConfig();
+		
+		if ($option == 'com_content' && $view == 'article' && $id)
+		{
+			if ($params->get('cache_items', 0)==1 && $conf->getValue( 'config.caching' )) {
+				$cache =& JFactory::getCache('mod_related_items', 'callback');
+				$cache->setLifeTime( $params->get( 'cache_time', $conf->getValue( 'config.cachetime' ) * 60 ) );
+				$cache->setCacheValidation(true);
+				$related = $cache->get(array('modRelatedItemsHelper', 'getRelatedItemsById'), array($id, $aid, $showDate));
+			} else {
+				$related = modRelatedItemsHelper::getRelatedItemsById($id, $aid, $showDate);
+			}
+		} else {
+			$related = array();
+		}
 
+		return $related;
+	}
 
+	function getRelatedItemsById($id, $aid, $showDate) {
+		$db =& JFactory::getDBO();
+		$user =& JFactory::getUser();
 		$date =& JFactory::getDate();
+
+		$related = array();
+
+		$nullDate = $db->getNullDate();
 		$now  = $date->toMySQL();
 
-		$related			= array();
+		// select the meta keywords from the item
+		$query = 'SELECT metakey' .
+				' FROM #__content' .
+				' WHERE id = '.(int) $id;
+		$db->setQuery($query);
 
-		if ($option == 'com_content' && $view == 'article' && $id)
+		if ($metakey = trim($db->loadResult()))
 		{
+			// explode the meta keys on a comma
+			$keys = explode(',', $metakey);
+			$likes = array ();
 
-			// select the meta keywords from the item
-			$query = 'SELECT metakey' .
-					' FROM #__content' .
-					' WHERE id = '.(int) $id;
-			$db->setQuery($query);
-
-			if ($metakey = trim($db->loadResult()))
+			// assemble any non-blank word(s)
+			foreach ($keys as $key)
 			{
-				// explode the meta keys on a comma
-				$keys = explode(',', $metakey);
-				$likes = array ();
-
-				// assemble any non-blank word(s)
-				foreach ($keys as $key)
-				{
-					$key = trim($key);
-					if ($key) {
-						$likes[] = ',' . $db->getEscaped($key) . ','; // surround with commas so first and last items have surrounding commas
-					}
+				$key = trim($key);
+				if ($key) {
+					$likes[] = ',' . $db->getEscaped($key) . ','; // surround with commas so first and last items have surrounding commas
 				}
+			}
 
-				if (count($likes))
-				{
-					// select other items based on the metakey field 'like' the keys found
-					$query = 'SELECT a.id, a.title, DATE_FORMAT(a.created, "%Y-%m-%d") AS created, a.sectionid, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state, s.published AS sec_state,' .
-							' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
-							' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
-							' FROM #__content AS a' .
-							' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' .
-							' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
-							' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
-							' WHERE a.id != '.(int) $id .
-							' AND a.state = 1' .
-							' AND a.access <= ' .(int) $user->get('aid', 0) .
-							' AND ( CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%'.implode('%" OR CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%', $likes).'%" )' . //remove single space after commas in keywords
-							' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
-							' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
-					$db->setQuery($query);
-					$temp = $db->loadObjectList();
+			if (count($likes))
+			{
+				// select other items based on the metakey field 'like' the keys found
+				$query = 'SELECT a.id, a.title, DATE_FORMAT(a.created, "%Y-%m-%d") AS created, a.sectionid, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state, s.published AS sec_state,' .
+						' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
+						' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
+						' FROM #__content AS a' .
+						' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' .
+						' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
+						' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
+						' WHERE a.id != '.(int) $id .
+						' AND a.state = 1' .
+						' AND a.access <= ' .(int) $user->get('aid', 0) .
+						' AND ( CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%'.implode('%" OR CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%', $likes).'%" )' . //remove single space after commas in keywords
+						' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
+						' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
+				$db->setQuery($query);
+				$temp = $db->loadObjectList();
 
-					if (count($temp))
+				if (count($temp))
+				{
+					foreach ($temp as $row)
 					{
-						foreach ($temp as $row)
+						if (($row->cat_state == 1 || $row->cat_state == '') && ($row->sec_state == 1 || $row->sec_state == '') && ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') && ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == ''))
 						{
-							if (($row->cat_state == 1 || $row->cat_state == '') && ($row->sec_state == 1 || $row->sec_state == '') && ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') && ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == ''))
-							{
-								$row->route = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
-								$related[] = $row;
-							}
+							$row->route = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
+							$related[] = $row;
 						}
 					}
-					unset ($temp);
 				}
+				unset ($temp);
 			}
 		}
 
 		return $related;
-	}
+	}	
 }
diff -aruN --binary 15/modules/mod_related_items/mod_related_items.php 16/modules/mod_related_items/mod_related_items.php
--- 15/modules/mod_related_items/mod_related_items.php	2009-05-29 13:54:04.000000000 +0200
+++ 16/modules/mod_related_items/mod_related_items.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_related_items.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_related_items.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_search/helper.php 16/modules/mod_search/helper.php
--- 15/modules/mod_search/helper.php	2009-05-29 13:54:12.000000000 +0200
+++ 16/modules/mod_search/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_search/mod_search.php 16/modules/mod_search/mod_search.php
--- 15/modules/mod_search/mod_search.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_search/mod_search.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_search.php 13338 2009-10-27 02:15:55Z ian $
+* @version		$Id: mod_search.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_search/tmpl/default.php 16/modules/mod_search/tmpl/default.php
--- 15/modules/mod_search/tmpl/default.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/modules/mod_search/tmpl/default.php	2010-04-23 13:40:18.000000000 +0200
@@ -39,5 +39,5 @@
 	</div>
 	<input type="hidden" name="task"   value="search" />
 	<input type="hidden" name="option" value="com_search" />
-	<input type="hidden" name="Itemid" value=<?php echo $mitemid; ?> />
+	<input type="hidden" name="Itemid" value="<?php echo $mitemid; ?>" />
 </form>
\ No hay ningún carácter de nueva línea al final del fichero
diff -aruN --binary 15/modules/mod_sections/helper.php 16/modules/mod_sections/helper.php
--- 15/modules/mod_sections/helper.php	2009-05-29 13:54:06.000000000 +0200
+++ 16/modules/mod_sections/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: helper.php 11074 2008-10-13 04:54:12Z ian $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/modules/mod_sections/mod_sections.php 16/modules/mod_sections/mod_sections.php
--- 15/modules/mod_sections/mod_sections.php	2009-05-29 13:54:06.000000000 +0200
+++ 16/modules/mod_sections/mod_sections.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: mod_sections.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: mod_sections.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
